#ifndef __CH32F10x_USBHOST_H__
#define __CH32F10x_USBHOST_H__

#include "ch32f10x_usb.h"

#ifdef __cplusplus
 extern "C" {
#endif

 /* ӳ򷵻״̬ */
#define ERR_SUCCESS          0x00    //ɹ
#define ERR_USB_CONNECT      0x15    //⵽USB豸¼
#define ERR_USB_DISCON       0x16    //⵽USB豸ϿӣѶϿ
#define ERR_USB_BUF_OVER     0x17    //USB̫໺
#define ERR_USB_DISK_ERR     0x1F    //USB洢ʧܣڳʼʱʱUSB洢֧֣ڶдпǴ𻵻ѾϿ
#define ERR_USB_TRANSFER     0x20    //NAK/STALL0x20~0x2f
#define ERR_USB_UNSUPPORT    0xFB    //ֵ֧USB豸
#define ERR_USB_UNKNOWN      0xFE    //Э汾
#define ERR_AOA_PROTOCOL     0x41    

 /* USB豸Ϣ  */
#define ROOT_DEV_DISCONNECT  0
#define ROOT_DEV_CONNECTED   1
#define ROOT_DEV_FAILED      2
#define ROOT_DEV_SUCCESS     3
#define DEV_TYPE_KEYBOARD   ( USB_DEV_CLASS_HID | 0x20 )
#define DEV_TYPE_MOUSE      ( USB_DEV_CLASS_HID | 0x30 )
#define DEF_AOA_DEVICE       0xF0
#define DEV_TYPE_UNKNOW 	   0xFF

 /*
  * ԼUSB豸ַ򣨲ο USB_DEVICE_ADDR
  * ֵַ     豸λ
  * 0x02    ROOT-HUBµUSB豸ⲿHUB
  * 0x1x    ROOT-HUBµⲿHUBĶ˿xµUSB豸xΪ1~n
  */
#define HUB_MAX_PORTS          	4
#define WAIT_USB_TOUT_200US     3000  //ȴUSBжϳʱʱ

 /* С */
#define COM_BUF_SIZE    128  //ɸĴС̬޸ѽʡڴ

extern const UINT8  SetupGetDevDescr[];   //ȡ豸
extern const UINT8  SetupGetCfgDescr[];   //ȡ
extern const UINT8  SetupSetUsbAddr[];    //USBַ
extern const UINT8  SetupSetUsbConfig[];  //USB
extern const UINT8  SetupSetUsbInterface[];//ýӿ
extern const UINT8  SetupClrEndpStall[];   //˵STALL
#ifndef DISK_BASE_BUF_LEN
extern const UINT8  SetupGetHubDescr[];   //ȡHUB
extern const UINT8  SetupSetHIDIdle[];   //ȡ
extern const UINT8  SetupGetHIDDevReport[];    //ȡHID豸
extern const UINT8  XPrinterReport[];  //ӡ
#endif
extern const UINT8  GetProtocol[];         //AOAȡЭ汾
extern const UINT8  TouchAOAMode[];        //ģʽ
extern const UINT8  Sendlen[];             /* AOA鶨 */
extern const UINT8  StringID[];            //ַID,ֻAPPصַϢ
extern const UINT8  SetStringID[];         //Ӧַ

#ifndef DISK_BASE_BUF_LEN
typedef struct
{
    UINT8   DeviceStatus;   // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;  // 豸USBַ
    UINT8   DeviceSpeed;    // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;     // 豸
		UINT16  DeviceVID;
		UINT16  DevicePID;
    UINT8   GpVar[4];         // ͨñŶ˵
    UINT8   GpHUBPortNum;     // ͨñ,HUBʾHUB˿
} _RootHubDev;

typedef struct
{
    UINT8   DeviceStatus;             // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;            // 豸USBַ
    UINT8   DeviceSpeed;              // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;               // 豸
    UINT16  DeviceVID;
    UINT16  DevicePID;
    UINT8   GpVar[4];                    // ͨñ
} _DevOnHubPort;                      // ٶ:1ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

extern _RootHubDev ThisUsbDev;
extern _DevOnHubPort DevOnHubPort[HUB_MAX_PORTS];// ٶ:1ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)
extern UINT8 Set_Port;
#endif

extern UINT8  UsbDevEndp0Size;     //USB豸Ķ˵0ߴ
extern UINT8 InEndpointMaxSize;
extern UINT8  RxBuffer[];                   // IN, must even address
extern UINT8  TxBuffer[];                   // OUT, must even address
extern UINT8  Com_Buffer[];
extern UINT8  FoundNewDev;
extern UINT8 EPint;
extern PUINT8  pHOST_RX_RAM_Addr;
extern PUINT8  pHOST_TX_RAM_Addr;
#define pSetupReq   ((PUSB_SETUP_REQ)pHOST_TX_RAM_Addr)


void  DisableRootHubPort(void)  ;        // رROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
UINT8   AnalyzeRootHub( void ) ;         // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
void    SetHostUsbAddr( UINT8 addr );    // USBǰUSB豸ַ
void    SetUsbSpeed( UINT8 FullSpeed );  // õǰUSBٶ
void    ResetRootHubPort(void);          // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
UINT8   EnableRootHubPort(void);         // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
void    SelectHubPort( UINT8 HubPortIndex );// HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
UINT8   WaitUSB_Interrupt( void );       // ȴUSBж
// ,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT32 timeout ); // endp_pid: 4λtoken_pid, 4λǶ˵ַ
UINT8   HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ
void CopySetupReqPkg( const UINT8 *pReqPkt );    // ƿƴ
UINT8 CtrlGetDeviceDescr( PUINT8 DataBuf );      // ȡ豸,TxBuffer
UINT8 CtrlGetConfigDescr( PUINT8 DataBuf );      // ȡ,TxBuffer
UINT8 CtrlSetUsbAddress( UINT8 addr ); // USB豸ַ
UINT8 CtrlSetUsbConfig( UINT8 cfg );   // USB豸
UINT8 CtrlClearEndpStall( UINT8 endp ) ; // ˵STALL
UINT8 CtrlSetUsbIntercace( UINT8 cfg );	//ýӿ

#ifndef DISK_BASE_BUF_LEN
UINT8   CtrlSetUsbIntercace( UINT8 cfg );              // USB豸ӿ
UINT8   CtrlGetHIDDeviceReport( UINT8 infc );          // HIDSET_IDLEGET_REPORT
UINT8   CtrlGetHubDescr( void );                       // ȡHUB,TxBuffer
UINT8   HubGetPortStatus( UINT8 HubPortIndex );        // ѯHUB˿״̬,TxBuffer
UINT8   HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
UINT8   HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
UINT8   CtrlGetXPrinterReport1( void ) ;               //ӡ
UINT8   AnalyzeHidIntEndp( PUINT8 buf, UINT8 HubPortIndex);           // зHIDж϶˵ĵַ
UINT8   AnalyzeBulkEndp( PUINT8 buf, UINT8 HubPortIndex ) ;           //˵
UINT8   AnalyzeInEndpointMaxSize( PUINT8 buf);
UINT8   TouchStartAOA( void );                         // AOA
UINT8   EnumAllRootDevice( void );                     // öROOT-HUB˿ڵUSB豸
UINT8   InitDevOnHub(UINT8 HubPortIndex );             // ʼöⲿHUBĶUSB豸
UINT8   EnumHubPort( );                                // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸
UINT8   EnumAllHubPort( void );                        // öROOT-HUB˿ⲿHUBĶUSB豸
UINT16  SearchTypeDevice( UINT8 type );                // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
                                                       // 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
UINT8 SETorOFFNumLock(PUINT8 buf);
#endif

void    USB_HostInit( void );   // ʼUSB
UINT8   InitRootDevice( void ); // ʼָROOT-HUB˿ڵUSB豸

#ifdef __cplusplus
}
#endif

#endif  /* __CH32F10x_USBHOST_H */

