/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32f10x_usb_host.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : This file provides all the USB firmware functions.
*******************************************************************************/ 
#include "ch32f10x_usb_host.h"
#include "debug.h"
#include "string.h"
#include "usb_desc.h"
#include "usb_lib.h"
#include "hw_config.h"
#include "usb_pwr.h"

/******************************** HOST DEVICE **********************************/
UINT8  UsbDevEndp0Size;			
UINT8  FoundNewDev;
UINT8 InEndpointMaxSize;
UINT8 GetHIDDevReportCount;
_RootHubDev   ThisUsbDev;             
UINT8 EPint;
PUINT8  pHOST_RX_RAM_Addr;
PUINT8  pHOST_TX_RAM_Addr;
/*ȡ豸*/
__attribute__ ((aligned(4))) const UINT8  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
/*ȡ*/
__attribute__ ((aligned(4))) const UINT8  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
/*USBַ*/
__attribute__ ((aligned(4))) const UINT8  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USB*/
__attribute__ ((aligned(4))) const UINT8  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USBӿ*/
__attribute__ ((aligned(4))) const UINT8  SetupSetUsbInterface[] = { USB_REQ_RECIP_INTERF, USB_SET_INTERFACE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*˵STALL*/
__attribute__ ((aligned(4))) const UINT8  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*ȡHUB*/
__attribute__ ((aligned(4))) const UINT8  SetupGetHubDescr[] = { HUB_GET_HUB_DESCRIPTOR, HUB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_HUB, 0x00, 0x00, sizeof( USB_HUB_DESCR ), 0x00 };
/* HIDв */
__attribute__ ((aligned(4))) const UINT8  SetupSetHIDIdle[]= { 0x21,HID_SET_IDLE,0x00,0x00,0x00,0x00,0x00,0x00 };
/*ȡHID豸*/
__attribute__ ((aligned(4))) const UINT8  SetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0xFF, 0x00 };
/*ӡ*/
__attribute__ ((aligned(4))) const UINT8  XPrinterReport[] = { 0xA1, 0, 0x00, 0, 0x00, 0x00, 0xF1, 0x03 };
//AOAȡЭ汾
__attribute__ ((aligned(4))) const UINT8  GetProtocol[] = { 0xc0,0x33,0x00,0x00,0x00,0x00,0x02,0x00 };
//ģʽ
__attribute__ ((aligned(4))) const UINT8  TouchAOAMode[] = { 0x40,0x35,0x00,0x00,0x00,0x00,0x00,0x00 };
/* AOA鶨 */
__attribute__ ((aligned(4))) const UINT8  Sendlen[]= {0,4,16,35,39,53,67};
//ַID,ֻAPPصַϢ
__attribute__ ((aligned(4))) const UINT8  StringID[] = {'W','C','H',0x00,                                                                                   //manufacturer name
                      'W','C','H','U','A','R','T','D','e','m','o',0x00,                                                   //model name
                      0x57,0x43,0x48,0x20,0x41,0x63,0x63,0x65,0x73,0x73,0x6f,0x72,0x79,0x20,0x54,0x65,0x73,0x74,0x00,     //description
                      '1','.','0',0x00 ,                                                                                  //version
                      0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77,0x63,0x68,0x2e,0x63,0x6e,0,                                 //URI
                      0x57,0x43,0x48,0x41,0x63,0x63,0x65,0x73,0x73,0x6f,0x72,0x79,0x31,0x00                               //serial number
                     };
//Ӧַ
__attribute__ ((aligned(4))) const UINT8  SetStringID[]= {0x40,0x34,0x00,0x00,0x00,0x00,0x04,0x00,
                        0x40,0x34,0x00,0x00,0x01,0x00,12,0x00,
                        0x40,0x34,0x00,0x00,0x02,0x00,19,0x00,
                        0x40,0x34,0x00,0x00,0x03,0x00,4,0x00,
                        0x40,0x34,0x00,0x00,0x04,0x00,0x0E,0x00,
                        0x40,0x34,0x00,0x00,0x05,0x00,0x0E,0x00
                       };

UINT8 Set_Port = 0;
_RootHubDev  ThisUsbDev;                                                   //ROOT
_DevOnHubPort  DevOnHubPort[HUB_MAX_PORTS];                                // ٶ1ⲿHUBÿⲿHUB_MAX_PORTS˿ڣ˲ܣ
UINT8 RootHubId;                                                                  // ǰڲroot-hub˿ں:0=HUB0,1=HUB1
UINT8 FoundNewDev;

/*******************************************************************************
* Function Name  : DisableRootHubPort( )
* Description    : رHUB˿
* Input          : None
* Return         : None
*******************************************************************************/
void DisableRootHubPort(void)          
{
#ifdef	FOR_ROOT_UDISK_ONLY
	CH103DiskStatus = DISK_DISCONNECT;
	
#endif
	
#ifndef	DISK_BASE_BUF_LEN
	ThisUsbDev.DeviceStatus = ROOT_DEV_DISCONNECT;
	ThisUsbDev.DeviceAddress = 0x00;
	
#endif
}

/*******************************************************************************
* Function Name  : AnalyzeRootHub
* Description    : root-hub״̬root-hub˿ڵ豸״̬
*                  豸γеDisableRootHubPort( )˿ڹرգ¼Ӧ˿ڵ״̬λ
* Input          : None
* Return         : ERR_SUCCESSΪûERR_USB_CONNECTΪ⵽ӣERR_USB_DISCONΪ⵽Ͽ
*******************************************************************************/
UINT8 AnalyzeRootHub( void ) 
{ 
	UINT8	s;
	
	s = ERR_SUCCESS;
	
	if ( R8_USB_MIS_ST & RB_UMS_DEV_ATTACH ) {  //豸
		
#ifdef DISK_BASE_BUF_LEN
		if ( CH103DiskStatus == DISK_DISCONNECT
			
#else
		if ( ThisUsbDev.DeviceStatus == ROOT_DEV_DISCONNECT      //⵽豸
			
#endif
				|| ( R8_UHOST_CTRL & RB_UH_PORT_EN ) == 0x00 ) { //⵽豸룬δ˵Ǹղ
				DisableRootHubPort( );                           //رն˿
					
#ifdef DISK_BASE_BUF_LEN
				CH103DiskStatus = DISK_CONNECT;
					
#else
        ThisUsbDev.DeviceSpeed = R8_USB_MIS_ST & RB_UMS_DM_LEVEL ? 0 : 1;
        ThisUsbDev.DeviceStatus = ROOT_DEV_CONNECTED;            //ӱ־
					
#endif
        s = ERR_USB_CONNECT;
     }
  }
	
#ifdef DISK_BASE_BUF_LEN
  else if ( CH103DiskStatus >= DISK_CONNECT ) {     //豸γ
		
#else
  else if ( ThisUsbDev.DeviceStatus >= ROOT_DEV_CONNECTED ) {
		
#endif
		DisableRootHubPort( );                      //رն˿
		if ( s == ERR_SUCCESS ) s = ERR_USB_DISCON;
  }
                                              
	return( s );
}

/*******************************************************************************
* Function Name  : SetHostUsbAddr
* Description    : USBǰUSB豸ַ
* Input          : addr; host address.
* Return         : None
*******************************************************************************/
void SetHostUsbAddr( UINT8 addr )
{
    R8_USB_DEV_AD = (R8_USB_DEV_AD&RB_UDA_GP_BIT) | (addr&MASK_USB_ADDR);
}

#ifndef	FOR_ROOT_UDISK_ONLY
/*******************************************************************************
* Function Name  : SetUsbSpeed
* Description    : õǰUSBٶ
* Input          : FullSpeed: USB speed.
* Return         : None
*******************************************************************************/
void SetUsbSpeed( UINT8 FullSpeed )  
{
	if ( FullSpeed )        //ȫ
	{
		R8_USB_CTRL &= ~ RB_UC_LOW_SPEED;         //ȫ
		R8_UH_SETUP &= ~ RB_UH_PRE_PID_EN;        //ֹPRE PID
	}
	else
	{
		R8_USB_CTRL |= RB_UC_LOW_SPEED;           //
	}
}
#endif

/*******************************************************************************
* Function Name  : ResetRootHubPort( )
* Description    : ⵽豸󣬸λߣΪö豸׼ĬΪȫ
* Input          : None  
* Return         : None
*******************************************************************************/
void ResetRootHubPort( void )
{
	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;     //USB豸ϵ0ߴ
#ifndef DISK_BASE_BUF_LEN
    memset( &ThisUsbDev,0,sizeof(ThisUsbDev));                                //սṹ
#endif
	SetHostUsbAddr( 0x00 );
	R8_UHOST_CTRL &= ~RB_UH_PORT_EN;                                          // ص˿
	SetUsbSpeed( 1 );                                                         // ĬΪȫ
	R8_UHOST_CTRL = (R8_UHOST_CTRL & ~RB_UH_LOW_SPEED) | RB_UH_BUS_RESET;     // ĬΪȫ,ʼλ
	Delay_Ms( 15 );                                                           // λʱ10mS20mS
	R8_UHOST_CTRL = R8_UHOST_CTRL & ~ RB_UH_BUS_RESET;                        // λ
	Delay_Us( 250 );
	R8_USB_INT_FG = RB_UIF_DETECT;                                            // жϱ־
}

/*******************************************************************************
* Function Name  : EnableRootHubPort( )
* Description    : ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
* Input          : None
* Return         : ERR_SUCCESSΪ⵽,ERR_USB_DISCONΪ
*******************************************************************************/
UINT8 EnableRootHubPort(void) 
{
#ifdef DISK_BASE_BUF_LEN
  if ( CH103DiskStatus < DISK_CONNECT ) CH103DiskStatus = DISK_CONNECT;
	
#else
  if ( ThisUsbDev.DeviceStatus < ROOT_DEV_CONNECTED ) ThisUsbDev.DeviceStatus = ROOT_DEV_CONNECTED;
	
#endif
  if ( R8_USB_MIS_ST & RB_UMS_DEV_ATTACH ) {     // 豸
#ifndef DISK_BASE_BUF_LEN
    if ( ( R8_UHOST_CTRL & RB_UH_PORT_EN ) == 0x00 ) {     // δʹ
			ThisUsbDev.DeviceSpeed = (R8_USB_MIS_ST & RB_UMS_DM_LEVEL) ? 0 : 1;
			if ( ThisUsbDev.DeviceSpeed == 0 ) R8_UHOST_CTRL |= RB_UH_LOW_SPEED;    // 
    }
		
#endif
    R8_UHOST_CTRL |= RB_UC_DMA_EN;     // USBDMA,жϱ־δǰԶͣ
    R8_UH_SETUP =RB_UH_SOF_EN;
    R8_UHOST_CTRL |= RB_UH_PORT_EN;    //ʹHUB˿
    return( ERR_SUCCESS );
  }
	
  return( ERR_USB_DISCON );
}
#ifndef DISK_BASE_BUF_LEN
/*******************************************************************************
* Function Name  : SelectHubPort( UINT8 HubPortIndex )
* Description    : ѡҪHUB
* Input          : UINT8 HubPortIndex ѡָROOT-HUB˿ڵⲿHUBָ˿
* Output         : None
* Return         : None
*******************************************************************************/
void    SelectHubPort( UINT8 HubPortIndex )
{
    if( HubPortIndex )                                                         // ѡָROOT-HUB˿ڵⲿHUBָ˿
    {
        SetHostUsbAddr( DevOnHubPort[HubPortIndex-1].DeviceAddress );          // USBǰUSB豸ַ
        SetUsbSpeed( DevOnHubPort[HubPortIndex-1].DeviceSpeed );               // õǰUSBٶ
        if ( DevOnHubPort[HubPortIndex-1].DeviceSpeed == 0 )                       // ͨⲿHUBUSB豸ͨѶҪǰID
        {
            R8_UH_SETUP |= RB_UH_PRE_PID_EN;                                        // PRE PID
            Delay_Us(100);
        }
    }
    else
    {
        SetHostUsbAddr( ThisUsbDev.DeviceAddress );                            // USBǰUSB豸ַ
        SetUsbSpeed( ThisUsbDev.DeviceSpeed );                                 // USB豸ٶ
    }
}
#endif

/*******************************************************************************
* Function Name  : WaitUSB_Interrupt
* Description    : ȴUSBж
* Input          : None
* Return         : ERR_SUCCESS ݽջ߷ͳɹ
                   ERR_USB_UNKNOWN ݽջ߷ʧ
*******************************************************************************/
UINT8 WaitUSB_Interrupt( void )
{
	UINT16  i;
	
	for ( i = WAIT_USB_TOUT_200US; i != 0 && (R8_USB_INT_FG&RB_UIF_TRANSFER) == 0; i -- ){;}
	return( (R8_USB_INT_FG&RB_UIF_TRANSFER)  ? ERR_SUCCESS : ERR_USB_UNKNOWN );
}

/*******************************************************************************
* Function Name  : USBHostTransact
* Description    : ,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
                   ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
* Input          : UINT8 endp_pid ƺ͵ַ  endp_pid: 4λtoken_pid, 4λǶ˵ַ
                   UINT8 tog      ͬ־
                   UINT16 timeout ʱʱ
* Output         : None
* Return         : ERR_USB_UNKNOWN ʱӲ쳣
                   ERR_USB_DISCON  豸Ͽ
                   ERR_USB_CONNECT 豸
                   ERR_SUCCESS     
*******************************************************************************/
UINT8 USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT32 timeout )
{
	UINT8	TransRetry;
	UINT8	s, r;
	UINT16	i;

	R8_UH_RX_CTRL = R8_UH_TX_CTRL = tog;
	TransRetry = 0;

	do {
		R8_UH_EP_PID = endp_pid;           // ָPIDĿĶ˵
		R8_USB_INT_FG = RB_UIF_TRANSFER;    // 
		for ( i = WAIT_USB_TOUT_200US; i != 0 && (R8_USB_INT_FG&RB_UIF_TRANSFER) == 0; i -- );
		R8_UH_EP_PID = 0x00;                  // ֹͣUSB
		if ( (R8_USB_INT_FG&RB_UIF_TRANSFER) == 0 )     {return( ERR_USB_UNKNOWN );}

		if ( R8_USB_INT_FG & RB_UIF_DETECT ) {   // USB豸¼
			R8_USB_INT_FG = RB_UIF_DETECT;       // жϱ־
			s = AnalyzeRootHub( );                // ROOT-HUB״̬

			if ( s == ERR_USB_CONNECT ) 			FoundNewDev = 1;
			
#ifdef DISK_BASE_BUF_LEN

			if ( CH103DiskStatus == DISK_DISCONNECT ) return( ERR_USB_DISCON ); // USB豸Ͽ¼
			if ( CH103DiskStatus == DISK_CONNECT ) return( ERR_USB_CONNECT );   // USB豸¼
      
#else
			if ( ThisUsbDev.DeviceStatus == ROOT_DEV_DISCONNECT ) return( ERR_USB_DISCON );// USB豸Ͽ¼
			if ( ThisUsbDev.DeviceStatus == ROOT_DEV_CONNECTED ) return( ERR_USB_CONNECT );// USB豸¼

#endif
			Delay_Us( 200 );  // ȴ
		}

		if ( R8_USB_INT_FG & RB_UIF_TRANSFER ) 							
		{  
			if ( R8_USB_INT_ST & RB_UIS_TOG_OK ) return( ERR_SUCCESS );
			r = R8_USB_INT_ST & MASK_UIS_H_RES;  // USB豸Ӧ״̬
			if ( r == USB_PID_STALL ) return( r | ERR_USB_TRANSFER );
			
			if ( r == USB_PID_NAK ) 
			{
				if ( timeout == 0 ) return( r | ERR_USB_TRANSFER );
				if ( timeout < 0xFFFF ) timeout --;
				-- TransRetry;
			}
			else switch ( endp_pid >> 4 ) {
				case USB_PID_SETUP:
					
				case USB_PID_OUT:
					if ( r ) return( r | ERR_USB_TRANSFER ); // ǳʱ/,Ӧ
					break;  // ʱ
				
				case USB_PID_IN:
					if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 ) {  // ͬ趪
					}  
					else if ( r ) return( r | ERR_USB_TRANSFER );  // ǳʱ/,Ӧ
					break;   // ʱ
					
				default:
					return( ERR_USB_UNKNOWN );   // ܵ
					break;
			}
		}
		else {  // ж,Ӧ÷
			R8_USB_INT_FG = 0xFF;  /* жϱ־ */
		}
		Delay_Us( 15 );	
	} while ( ++ TransRetry < 3 );
	
	return( ERR_USB_TRANSFER );  // Ӧʱ
}

/*******************************************************************************
* Function Name  : HostCtrlTransfer
* Description    : ִпƴ,8ֽpSetupReq,DataBufΪѡշ
* Input          : PUINT8X DataBuf Ҫպͷ,ôDataBufָЧڴź
                   PUINT8 RetLen  ʵʳɹշܳȱRetLenָֽڱ
* Output         : None
* Return         : ERR_USB_BUF_OVER IN״̬׶γ
                   ERR_SUCCESS     ݽɹ
                   ״̬
*******************************************************************************/
UINT8 HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen )  
{
	UINT16  RemLen  = 0;
	UINT8   s, RxLen, RxCnt, TxCnt;
	PUINT8  pBuf;
	PUINT8   pLen;

	pBuf = DataBuf;
	pLen = RetLen;
	Delay_Us( 200 );
	if ( pLen )	*pLen = 0;  		// ʵʳɹշܳ

	R8_UH_TX_LEN = sizeof( USB_SETUP_REQ );
	s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );       // SETUP׶,200mSʱ
	if ( s != ERR_SUCCESS ) return( s );
	R8_UH_RX_CTRL = R8_UH_TX_CTRL = RB_UH_R_TOG | RB_UH_R_AUTO_TOG | RB_UH_T_TOG | RB_UH_T_AUTO_TOG;// ĬDATA1
	R8_UH_TX_LEN = 0x01;                                                     // Ĭݹ״̬׶ΪIN
	RemLen = pSetupReq -> wLength;
	
	if ( RemLen && pBuf )                                    // Ҫշ
	{
		if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN )    // 
		{
			while ( RemLen )
			{
				Delay_Us( 200 );
				s = USBHostTransact( USB_PID_IN << 4 | 0x00, R8_UH_RX_CTRL, 200000/20 );// IN
				if ( s != ERR_SUCCESS )         return( s );
				RxLen = R8_USB_RX_LEN < RemLen ? R8_USB_RX_LEN : RemLen;
				RemLen -= RxLen;
				if ( pLen ) *pLen += RxLen;  // ʵʳɹշܳ
				
				for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ )
				{
					*pBuf = pHOST_RX_RAM_Addr[ RxCnt ];
					printf("%2X",pHOST_RX_RAM_Addr[ RxCnt ]);
					pBuf ++;
				}
				printf("\r\n");
				if ( R8_USB_RX_LEN == 0 || ( R8_USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) ) break;   // ̰
			}
			R8_UH_TX_LEN = 0x00;                        // ״̬׶ΪOUT
		}
		else                                                              
		{
			while ( RemLen )// 
			{
				Delay_Us( 200 );
				R8_UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;
#ifndef DISK_BASE_BUF_LEN
                if(pBuf[1] == 0x09)                                              //HID
                {
                    Set_Port = Set_Port^1;
                    *pBuf = Set_Port;
#if DE_PRINTF
                    printf("SET_PORT  %02X  %02X ",(UINT16)(*pBuf),(UINT16)(Set_Port));
#endif
                }
#endif
				for ( TxCnt = 0; TxCnt != R8_UH_TX_LEN; TxCnt ++ )
				{
					pHOST_TX_RAM_Addr[ TxCnt ] = *pBuf;
					pBuf ++;
				}
				
				s = USBHostTransact( USB_PID_OUT << 4 | 0x00, R8_UH_TX_CTRL, 200000/20 );// OUT
				if ( s != ERR_SUCCESS ) return( s );
				RemLen -= R8_UH_TX_LEN;
				if ( pLen ) *pLen += R8_UH_TX_LEN;  // ʵʳɹշܳ
			}
		}
	}
	
	Delay_Us( 200 );
	s = USBHostTransact( ( R8_UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), RB_UH_R_TOG | RB_UH_T_TOG, 200000/20 ); // STATUS׶
	if ( s != ERR_SUCCESS )         return( s );    
	if ( R8_UH_TX_LEN == 0 )        return( ERR_SUCCESS );    // ״̬OUT
	if ( R8_USB_RX_LEN == 0 )       return( ERR_SUCCESS );     // ״̬IN,IN״̬ݳ
	
	return( ERR_USB_BUF_OVER );                                  // IN״̬׶δ
}

/*******************************************************************************
* Function Name  : CopySetupReqPkg
* Description    : ƿƴ
* Input          : PUINT8C pReqPkt ַ
* Output         : None
* Return         : None
*******************************************************************************/
void CopySetupReqPkg( const UINT8 *pReqPkt )          
{
	UINT8 i;
	
	for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ )
	{
		((PUINT8)pSetupReq)[ i ] = *pReqPkt;
		pReqPkt++;
	}
}

/*******************************************************************************
* Function Name  : CtrlGetDeviceDescr
* Description    : ȡ豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlGetDeviceDescr( PUINT8 DataBuf )
{
	UINT8   s;
	UINT8  len;

	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
	CopySetupReqPkg( SetupGetDevDescr );
	s = HostCtrlTransfer( DataBuf, &len );
	memcpy(USBD_DeviceDescriptor,DataBuf,len);
	printf("USBD_DeviceDescriptor\n");
	for(int i=0; i<len;i++)
	{
	    printf(" x%02x",USBD_DeviceDescriptor[i]);
	}
    printf("\r\n");
	if ( s != ERR_SUCCESS ) return( s );
	UsbDevEndp0Size = ( (PUSB_DEV_DESCR)DataBuf ) -> bMaxPacketSize0;       
	if ( len < ((PUSB_SETUP_REQ)SetupGetDevDescr)->wLength ) return( ERR_USB_BUF_OVER ); 
	return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlGetConfigDescr
* Description    : ȡ,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlGetConfigDescr( PUINT8 DataBuf )
{
	UINT8   s;
	UINT8  len;
	CopySetupReqPkg( SetupGetCfgDescr );
	s = HostCtrlTransfer( DataBuf, &len );     // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLength ) return( ERR_USB_BUF_OVER );  

	len = ( (PUSB_CFG_DESCR)DataBuf ) -> wTotalLength;	
	CopySetupReqPkg( SetupGetCfgDescr ); // ܳ
	pSetupReq ->wLength = len;                                              
	s = HostCtrlTransfer( DataBuf, &len );    // ִпƴ
    memcpy(USBD_ConfigDescriptor,DataBuf,len);
    printf("USBD_ConfigDescriptor\n");
    for(int i=0; i<len;i++)
    {
        printf(" x%02x",USBD_ConfigDescriptor[i]);
    }
    printf("\r\n");
	if ( s != ERR_SUCCESS ) return( s );

#ifdef DISK_BASE_BUF_LEN
    if(len>64) len = 64;
    memcpy(TxBuffer,Com_Buffer,len);                                             //U̲ʱҪTxBuffer
#endif
    InEndpointMaxSize=AnalyzeInEndpointMaxSize(DataBuf);
	return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlSetUsbAddress
* Description    : USB豸ַ
* Input          : UINT8 addr 豸ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlSetUsbAddress( UINT8 addr ) 
{
	UINT8   s;
	CopySetupReqPkg( SetupSetUsbAddr );	
	pSetupReq -> wValue = addr;              // USB豸ַ
	s = HostCtrlTransfer( NULL, NULL );     // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	SetHostUsbAddr( addr );              // USBǰUSB豸ַ
	Delay_Ms( 10 );                 // ȴUSB豸ɲ
	return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlSetUsbConfig
Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlSetUsbConfig( UINT8 cfg )                   
{
	CopySetupReqPkg( SetupSetUsbConfig );	
	pSetupReq -> wValue = cfg;                    // USB豸
	return( HostCtrlTransfer( NULL, NULL ) );     // ִпƴ
}

/*******************************************************************************
* Function Name  : CtrlClearEndpStall
* Description    : ˵STALL
* Input          : UINT8 endp       ˵ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlClearEndpStall( UINT8 endp )  
{
	CopySetupReqPkg( SetupClrEndpStall );           // ˵Ĵ
	pSetupReq -> wIndex = endp;                     // ˵ַ
	return( HostCtrlTransfer( NULL, NULL ) );       // ִпƴ
}
#ifndef DISK_BASE_BUF_LEN
/*******************************************************************************
* Function Name  : CtrlSetUsbIntercace
* Description    : USB豸ӿ
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8 CtrlSetUsbIntercace( UINT8 cfg )                   
{
	CopySetupReqPkg( SetupSetUsbInterface );		
	pSetupReq -> wValue = cfg;                   // USB豸
	return( HostCtrlTransfer( NULL, NULL ) );    // ִпƴ
}

/*******************************************************************************
* Function Name  : CtrlGetHIDDeviceReport
* Description    : ȡHID豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8   CtrlGetHIDDeviceReport( UINT8 infc )
{
    UINT8   s;
    UINT8   len;

    CopySetupReqPkg( SetupSetHIDIdle );
    pSetupReq -> wIndex = infc;
    s = HostCtrlTransfer( Com_Buffer, (PUINT8)&len );                            // ִпƴ
    GetHIDDevReportCount++;
    if ( s != ERR_SUCCESS )
    {
        GetHIDDevReportCount=0;
        return( s );
    }

    CopySetupReqPkg( SetupGetHIDDevReport );
    pSetupReq -> wIndex = infc;
    s = HostCtrlTransfer( Com_Buffer, (PUINT8)&len );                            // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        GetHIDDevReportCount=0;
        return( s );
    }

    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : CtrlGetHubDescr
* Description    : ȡHUB,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_BUF_OVER ȴ
*******************************************************************************/
UINT8   CtrlGetHubDescr( void )
{
    UINT8   s;
    UINT8  len;
    CopySetupReqPkg( SetupGetHubDescr );
    s = HostCtrlTransfer( Com_Buffer, (PUINT8)&len );                          // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetHubDescr ) -> wLength )
    {
        return( ERR_USB_BUF_OVER );                                            // ȴ
    }
//  if ( len < 4 ) return( ERR_USB_BUF_OVER );                                 // ȴ
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : HubGetPortStatus
* Description    : ѯHUB˿״̬,Com_Buffer
* Input          : UINT8 HubPortIndex
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_BUF_OVER ȴ
*******************************************************************************/
UINT8   HubGetPortStatus( UINT8 HubPortIndex )
{
    UINT8   s;
    UINT8  len;

    pSetupReq -> bRequestType = HUB_GET_PORT_STATUS;
    pSetupReq -> bRequest = HUB_GET_STATUS;
    pSetupReq -> wValue = 0x0000;
    pSetupReq -> wIndex = 0x0000|HubPortIndex;
    pSetupReq -> wLength = 0x0004;
    s = HostCtrlTransfer( Com_Buffer, &len );                           // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < 4 )
    {
        return( ERR_USB_BUF_OVER );                                             // ȴ
    }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : HubSetPortFeature
* Description    : HUB˿
* Input          : UINT8 HubPortIndex    //HUB˿
                   UINT8 FeatureSelt     //HUB˿
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8   HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{
    pSetupReq -> bRequestType = HUB_SET_PORT_FEATURE;
    pSetupReq -> bRequest = HUB_SET_FEATURE;
    pSetupReq -> wValue = 0x0000|FeatureSelt;
    pSetupReq -> wIndex = 0x0000|HubPortIndex;
    pSetupReq -> wLength = 0x0000;
    return( HostCtrlTransfer( NULL, NULL ) );                                 // ִпƴ
}

/*******************************************************************************
* Function Name  : HubClearPortFeature
* Description    : HUB˿
* Input          : UINT8 HubPortIndex                                         //HUB˿
                   UINT8 FeatureSelt                                          //HUB˿
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8   HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{
    pSetupReq -> bRequestType = HUB_CLEAR_PORT_FEATURE;
    pSetupReq -> bRequest = HUB_CLEAR_FEATURE;
    pSetupReq -> wValue = 0x0000|FeatureSelt;
    pSetupReq -> wIndex = 0x0000|HubPortIndex;
    pSetupReq -> wLength = 0x0000;
    return( HostCtrlTransfer( NULL, NULL ) );                                // ִпƴ
}

/*******************************************************************************
* Function Name  : CtrlGetXPrinterReport1
* Description    : ӡ
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetXPrinterReport1( void )
{
    UINT8   s;
    UINT16   len;
    CopySetupReqPkg( XPrinterReport );
    s = HostCtrlTransfer( Com_Buffer, (PUINT8)&len );                         // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
//     if ( len < ( (XPrinterReport[7]<<8)|(XPrinterReport[6]) ))
//     {
//         return( ERR_USB_BUF_OVER );                                        // ȴ
//     }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : AnalyzeHidIntEndp
* Description    : зHIDж϶˵ĵַ,HubPortIndex0浽ROOTHUBǷֵ򱣴浽HUB½ṹ
* Input          : PUINT8 buf  ݻַ HubPortIndex0ʾHUB0ʾⲿHUBµĶ˿ں
* Output         : None
* Return         : ˵
*******************************************************************************/
UINT8   AnalyzeHidIntEndp( PUINT8 buf, UINT8 HubPortIndex )
{
    UINT8   i, s, l;
       s = 0;
   if(HubPortIndex)
       memset( DevOnHubPort[HubPortIndex-1].GpVar,0,sizeof(DevOnHubPort[HubPortIndex-1].GpVar) ); //
   else
           memset( ThisUsbDev.GpVar,0,sizeof(ThisUsbDev.GpVar) );                     //
   for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLength; i += l )       // ж϶˵,ͽӿ
      {
          if ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP  // Ƕ˵
                  && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_INTER// ж϶˵
                  && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ) )// IN˵
          {           // ж϶˵ĵַ,λ7ͬ־λ,0
              if(HubPortIndex)
                  DevOnHubPort[HubPortIndex-1].GpVar[s] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
              else
                  ThisUsbDev.GpVar[s] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;// ж϶˵ĵַԸҪwMaxPacketSizebInterval
  #if DE_PRINTF
              printf("%02x ",(UINT16)ThisUsbDev.GpVar[s]);
  #endif
              s++;
              if(s >= 4) break;   //ֻ4˵

          }
          l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                          // ǰ,
          if ( l > 16 )
          {
              break;
          }
      }
  #if DE_PRINTF
      printf("\n");
  #endif
      return( s );
}

/*******************************************************************************
* Function Name  : AnalyzeBulkEndp
* Description    : ˵,GpVar[0]GpVar[1]ϴ˵㡣GpVar[2]GpVar[3]´˵
* Input          : bufݻַ   HubPortIndex0ʾHUB0ʾⲿHUBµĶ˿ں
* Output         : None
* Return         : 0
*******************************************************************************/
UINT8   AnalyzeBulkEndp( PUINT8 buf, UINT8 HubPortIndex )
{
    UINT8   i, s1,s2, l;
    s1 = 0;s2 = 2;

    if(HubPortIndex)
        memset( DevOnHubPort[HubPortIndex-1].GpVar,0,sizeof(DevOnHubPort[HubPortIndex-1].GpVar) ); //
    else
        memset( ThisUsbDev.GpVar,0,sizeof(ThisUsbDev.GpVar) );                     //

    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLength; i += l )       // ж϶˵,ͽӿ
    {
        if ( (( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP)     // Ƕ˵
                && ((( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_BULK))

        {
            if(HubPortIndex)
            {
                if(( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK )
                    DevOnHubPort[HubPortIndex-1].GpVar[s1++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
                else
                    DevOnHubPort[HubPortIndex-1].GpVar[s2++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
            }
            else
            {
                if(( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK )
                    ThisUsbDev.GpVar[s1++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
                else
                    ThisUsbDev.GpVar[s2++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
            }

            if(s1 == 2) s1 = 1;
            if(s2 == 4) s2 = 3;
        }
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                          // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( 0 );
}

/*******************************************************************************
* Function Name  : AnalyzeInEndpointMaxSize
* Description    : ˵ֽ
* Input          : bufݻַ   HubPortIndex0ʾHUB0ʾⲿHUBµĶ˿ں
* Output         : None
* Return         : 0
*******************************************************************************/
UINT8   AnalyzeInEndpointMaxSize( PUINT8 buf)
{
    UINT8   i, l;
    UINT16   s=0;

    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLength; i += l )       // ж϶˵,ͽӿ
    {
        if ( (( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP)     // Ƕ˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ))  // ˵
        {
            s=( (PXUSB_ENDP_DESCR)(buf+i) ) -> wMaxPacketSize ;
            printf("s==%x\r\n",s);
            break;
        }
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                          // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( s );
}

//AOAģʽ
UINT8 TouchStartAOA(void)
{
    UINT8 len,s,i,Num;
    UINT16 cp_len;
    //ȡЭ汾
    CopySetupReqPkg( GetProtocol );
    s = HostCtrlTransfer( Com_Buffer, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if(Com_Buffer[0]<2) return  ERR_AOA_PROTOCOL;

    //ַ
    for(i=0; i<6; i++)
    {
        Num=Sendlen[i];
        CopySetupReqPkg(&SetStringID[8*i]);
        cp_len = (pSetupReq -> wLength );
        memcpy(Com_Buffer,&StringID[Num],cp_len);
        s = HostCtrlTransfer( Com_Buffer, &len );  // ִпƴ
        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
    }

    CopySetupReqPkg(TouchAOAMode);
    s = HostCtrlTransfer( Com_Buffer, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    return ERR_SUCCESS;
}


/*****************************************************************************
* Function Name  : InitRootDevice
* Description    : ʼָROOT-HUB˿ڵUSB豸
* Input          : UINT8 RootHubIndex ָ˿ڣHUB˿ں0/1
* Output         : None
* Return         :
*******************************************************************************/
UINT8 InitRootDevice( void )
{
	UINT8  i, s, t;
	UINT8  cfg, dv_cls, if_cls, ifc;
	UINT8 touchaoatm = 0;
	t = 0;
	
#if DE_PRINTF
    printf( "Reset USB Port\n");
#endif
USBDevEnum:
    for(i=0;i<t;i++)
    {
        Delay_Ms( 100 );
       if(t>10) return( s );
    }
    ResetRootHubPort( ); // ⵽豸,λӦ˿ڵUSB
	for ( i = 0, s = 0; i < 100; i ++ )  // ȴUSB豸λ,100mSʱ
	{  				
		Delay_Ms( 1 );
		if ( EnableRootHubPort( ) == ERR_SUCCESS ) {   // ʹROOT-HUB˿
				i = 0;
				s ++;  					 // ʱȴUSB豸Ӻȶ
				if ( s > 100 ) break;  	 // Ѿȶ15mS
		}
	}
	
	if ( i )   // λ豸û
	{  										
		DisableRootHubPort( );
#if DE_PRINTF
        printf( "Disable usb port because of disconnect\n" );
#endif
		return( ERR_USB_DISCON );
	}
	SelectHubPort( 0 );
#if DE_PRINTF
    printf( "GetDevDescr: " );
#endif
//	SetUsbSpeed( ThisUsbDev.DeviceSpeed );  //usb speed
	s = CtrlGetDeviceDescr( Com_Buffer );  //豸
	if ( s == ERR_SUCCESS )
	{
#if DE_PRINTF
        for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLength ; i ++ )
        {
            printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
        }
        printf( "\n" );                                                      // ʾ
#endif
		ThisUsbDev.DeviceVID = ((PUSB_DEV_DESCR)Com_Buffer)->idVendor; //VID PIDϢ
		ThisUsbDev.DevicePID = ((PUSB_DEV_DESCR)Com_Buffer)->idProduct;
		dv_cls = ( (PUSB_DEV_DESCR)Com_Buffer ) -> bDeviceClass;// 豸
		s = CtrlSetUsbAddress( ((PUSB_SETUP_REQ)SetupSetUsbAddr)->wValue ); // USB豸ַ,RootHubIndexԱ֤2HUB˿ڷ䲻ͬĵַ
		if ( s == ERR_SUCCESS )
		{
			ThisUsbDev.DeviceAddress = ( (PUSB_SETUP_REQ)SetupSetUsbAddr )->wValue;   // USBַ
#if DE_PRINTF
            printf( "GetCfgDescr: " );
#endif
            s = CtrlGetConfigDescr( Com_Buffer );//
            EPint=AnalyzeHidIntEndp( USBD_ConfigDescriptor, 0 );//˵ֵ
            printf("EPint=%d\r\n",EPint);
			if ( s == ERR_SUCCESS ) 
			{			
			  cfg = ( (PUSB_CFG_DESCR)Com_Buffer )->bConfigurationValue;
			  ifc=  ( (PXUSB_CFG_DESCR)Com_Buffer ) -> bNumInterfaces;
#if DE_PRINTF
			  printf( "ConfigDescr: " );
                for ( i = 0; i < ( (PXUSB_CFG_DESCR)Com_Buffer ) -> wTotalLength; i ++ )
                {
                    printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
                }
                printf("\n");
#endif
                                                          //,ȡ˵/˵ַ/˵С,±endp_addrendp_size
			  if_cls = ( (PUSB_CFG_DESCR_LONG)Com_Buffer )->itf_descr.bInterfaceClass;  // ӿ
			  if ( (dv_cls == 0x00) && (if_cls == USB_DEV_CLASS_STORAGE)) {  // USB洢豸,ȷU
			      AnalyzeBulkEndp(Com_Buffer , 0 );
#if DE_PRINTF
                    for(i=0;i!=4;i++)
                    {
                        printf("%02x ",(UINT16)ThisUsbDev.GpVar[i] );
                    }
                    printf("\n");
#endif
				s = CtrlSetUsbConfig( cfg );   // USB豸
				
				if ( s == ERR_SUCCESS )
			  {
					ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
					ThisUsbDev.DeviceType = USB_DEV_CLASS_STORAGE;
#if DE_PRINTF
                        printf( "USB-Disk Ready\n" );
#endif
					SetUsbSpeed( 1 );  // ĬΪȫ
					return( ERR_SUCCESS );
			  }
			}
		  else if ( (dv_cls == 0x00) && (if_cls == USB_DEV_CLASS_PRINTER) && ((PUSB_CFG_DESCR_LONG)Com_Buffer)->itf_descr.bInterfaceSubClass == 0x01 ) {  // Ǵӡ豸
#if DE_PRINTF
                    printf( "USB-Print OK\n" );
#endif
                    if((Com_Buffer[19] == 5)&&(Com_Buffer[20]&&0x80)){
                       ThisUsbDev.GpVar[0] = Com_Buffer[20];                     //IN ˵
                    }
                    else if((Com_Buffer[19] == 5)&&((Com_Buffer[20]&&0x80) == 0)){
                       ThisUsbDev.GpVar[1] = Com_Buffer[20];                    //OUT ˵
                    }
                    if((Com_Buffer[26] == 5)&&(Com_Buffer[20]&&0x80)){
                       ThisUsbDev.GpVar[0] = Com_Buffer[27];                     //IN ˵
                    }
                    else if((Com_Buffer[26] == 5)&&((Com_Buffer[20]&&0x80) == 0)){
                       ThisUsbDev.GpVar[1] = Com_Buffer[27];                    //OUT ˵
                    }
		      s = CtrlSetUsbConfig( cfg );  // USB豸
				if ( s == ERR_SUCCESS ) {
				    s = CtrlSetUsbIntercace(cfg);
				    //豣˵ϢԱUSB
				    s = CtrlGetXPrinterReport1( );                    //ӡ
				    if(s == ERR_SUCCESS){
                          ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                          ThisUsbDev.DeviceType = USB_DEV_CLASS_PRINTER;
#if DE_PRINTF
                          printf( "USB-Print Ready\n" );
#endif
                          SetUsbSpeed( 1 );                               // ĬΪȫ
                          return( ERR_SUCCESS );
                        }
				}
			}
		  else if ( (dv_cls == 0x00) && (if_cls == USB_DEV_CLASS_HID) && ((PUSB_CFG_DESCR_LONG)Com_Buffer)->itf_descr.bInterfaceSubClass <= 0x01 ) { // HID豸,/
		      s = AnalyzeHidIntEndp( Com_Buffer,0 );                    // зHIDж϶˵ĵַ
#if DE_PRINTF
                    printf( "AnalyzeHidIntEndp %02x\n",(UINT16)s );
#endif
		      if_cls = ( (PUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceProtocol;
#if DE_PRINTF
                    printf( "CtrlSetUsbConfig %02x\n",(UINT16)cfg );
#endif
			  s = CtrlSetUsbConfig( cfg ); // USB豸
				if ( s == ERR_SUCCESS ) {
#if DE_PRINTF
                        printf( "GetHIDReport: " );
#endif
                    for(dv_cls=0;dv_cls<ifc;dv_cls++)
                    {
                        s = CtrlGetHIDDeviceReport(dv_cls);                    //ȡ

                            if(dv_cls==0)
                            {
                                memcpy(Interface0RepDesc,Com_Buffer,125);
                                printf("Interface0RepDesc\n");
                                for(int i=0; i<125;i++)
                                {
                                    printf(" x%02x",Interface0RepDesc[i]);
                                }
                                printf("\r\n");

                            }else if(dv_cls==1)
                            {
                                memcpy(Interface1RepDesc,Com_Buffer,125);
                                printf("Interface1RepDesc\n");
                                for(int i=0; i<125;i++)
                                {
                                    printf(" x%02x",Interface1RepDesc[i]);
                                }
                                printf("\r\n");
                            }else {
                                memcpy(Interface2RepDesc,Com_Buffer,125);
                                printf("RepDesc\n");
                                for(int i=0; i<125;i++)
                                {
                                    printf(" x%02x",Interface2RepDesc[i]);
                                }
                                printf("\r\n");
                            }

                        if(s == ERR_SUCCESS)
                        {
#if DE_PRINTF
             for ( i = 0; i < 125; i++ )
             {
                 printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
             }
             printf("\n");
#endif

                        }
                    }
				                                                    //豣˵ϢԱUSB
				    ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
					if ( if_cls == 1 ) {
						ThisUsbDev.DeviceType = DEV_TYPE_KEYBOARD;
						                                            //һʼ,豸ָʾLED
						if(ifc > 1)
                        {
#if DE_PRINTF
                            printf( "USB_DEV_CLASS_HID Ready\n" );
#endif
                            ThisUsbDev.DeviceType = USB_DEV_CLASS_HID;//HID豸
                        }
#if DE_PRINTF
                        printf( "USB-Keyboard Ready\n" );
#endif
					    SetUsbSpeed( 1 );   // ĬΪȫ
						return( ERR_SUCCESS );
					}
				  else if ( if_cls == 2 ) {
						ThisUsbDev.DeviceType = DEV_TYPE_MOUSE;
						                        //ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
						if(ifc > 1)
                        {
#if DE_PRINTF
                            printf( "USB_DEV_CLASS_HID Ready\n" );
#endif
                            ThisUsbDev.DeviceType = USB_DEV_CLASS_HID;//HID豸
                        }
#if DE_PRINTF
                        printf( "USB-Mouse Ready\n" );
#endif
                        SetUsbSpeed( 1 );                            // ĬΪȫ
					  return( ERR_SUCCESS );
				  }
				  s = ERR_USB_UNSUPPORT;
			  }
			}
		  else if(dv_cls == USB_DEV_CLASS_HUB) {  // HUB豸,
			    s = AnalyzeHidIntEndp( Com_Buffer,0 );                    // зHIDж϶˵ĵַ
#if DE_PRINTF
                printf( "AnalyzeHidIntEndp %02x\n",(UINT16)s );
#endif
#if DE_PRINTF
                printf( "GetHubDescr: ");
#endif
				s = CtrlSetUsbConfig( cfg );  
				if ( s == ERR_SUCCESS ) {
#if DE_PRINTF
                for( i = 0; i < Com_Buffer[0]; i++ )
                {
                    printf( "x%02X ",(UINT16)(Com_Buffer[i]) );
                }
                printf("\n");
#endif
                ThisUsbDev.GpHUBPortNum = ( (PXUSB_HUB_DESCR)Com_Buffer ) -> bNbrPorts;// HUBĶ˿
                if ( ThisUsbDev.GpHUBPortNum > HUB_MAX_PORTS )
                {
                    ThisUsbDev.GpHUBPortNum = HUB_MAX_PORTS;// ΪṹDevOnHubPortʱΪٶÿHUBHUB_MAX_PORTS˿
                }
                //if ( ( (PXUSB_HUB_DESCR)Com_Buffer ) -> wHubCharacteristics[0] & 0x04 ) printf("мĸ豸\n");
                //else printf("һļƷ\n");
                s = CtrlSetUsbConfig( cfg );                     // USB豸
                if ( s == ERR_SUCCESS )
                {
                    ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                    ThisUsbDev.DeviceType = DEV_TYPE_UNKNOW;
                    //豣˵ϢԱUSB,ж϶˵HUB¼֪ͨ,ʹòѯ״̬ƴ
                    //HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
                    for ( i = 1; i <= ThisUsbDev.GpHUBPortNum; i ++ )// HUB˿ڶϵ
                    {
                        DevOnHubPort[i-1].DeviceStatus = ROOT_DEV_DISCONNECT;  // ⲿHUB˿豸״̬
                        s = HubSetPortFeature( i, HUB_PORT_POWER );
                        if ( s != ERR_SUCCESS )
                        {
#if DE_PRINTF
                            printf( "Ext-HUB Port_%1d# power on error\n",(UINT16)i );// ˿ϵʧ
#endif
                        }
                    }

//                          for ( i = 1; i <= ThisUsbDev.GpVar[0]; i ++ )            // ѯHUB˿״̬
//                          {
//                              s = HubGetPortStatus( i );                           // ȡ˿״̬
//                              if ( s != ERR_SUCCESS )
//#if DE_PRINTF
//                              printf( "Ext-HUB Port_%1d#  clear connection error\n",(UINT16)i );  // ˿״̬ʧ
//#endif
//                          }
                    SetUsbSpeed( 1 );
                  return( ERR_SUCCESS );
                }

			  }
			}
		  else{//豸
#if DE_PRINTF
                    printf( "dv_cls %02x\n",(UINT16)dv_cls );
                    printf( "if_cls %02x\n",(UINT16)if_cls );
                    printf( "if_subcls %02x\n",(UINT16)( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceSubClass );
#endif
          AnalyzeBulkEndp(Com_Buffer , 0 );                                  //˵
#if DE_PRINTF
                    for(i=0;i!=4;i++)
                    {
                        printf("%02x ",(UINT16)ThisUsbDev.GpVar[i] );
                    }
                    printf("\n");
#endif
                    s = CtrlSetUsbConfig( cfg );                                     // USB豸
                    if ( s == ERR_SUCCESS )
                   {
#if DE_PRINTF
                       printf("%02x %02x\n",(UINT16)ThisUsbDev.DeviceVID,(UINT16)ThisUsbDev.DevicePID);
#endif
                       if((ThisUsbDev.DeviceVID==0x18D1)&&(ThisUsbDev.DevicePID&0xff00)==0x2D00)   //AOA
                       {
                           printf("AOA Mode\n");
                           ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                           ThisUsbDev.DeviceType = DEF_AOA_DEVICE;                      //ֻԶı࣬USBЭ
                           SetUsbSpeed( 1 );                                            // ĬΪȫ
                           return( ERR_SUCCESS );
                       }
                       else   //AOA ģʽģʽ.
                       {
                           s = TouchStartAOA();
                           if( s == ERR_SUCCESS )
                           {
                               if(touchaoatm<3)         //AOA
                               {
                                   touchaoatm++;
                                   Delay_Ms(500);      //ְ׿豸ԶϿԴ˴ʱ
                                   goto USBDevEnum;    //ʵԲתAOAЭ涨豸Զ½ߡ
                               }
                               //ִе⣬˵֧ܲAOA豸
                               ThisUsbDev.DeviceType = dv_cls ? dv_cls : if_cls;
                               ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
                               SetUsbSpeed( 1 );                                            // ĬΪȫ
                               return( ERR_SUCCESS );                                       // δ֪豸ʼɹ
                           }
                       }
                   }
		      }
		  }
		}
	}
#if DE_PRINTF
    printf( "InitRootDev Err = %02X\n", (UINT16)s );
#endif
    ThisUsbDev.DeviceStatus = ROOT_DEV_FAILED;
    SetUsbSpeed( 1 );                                                                 // ĬΪȫ
    t++;
    goto USBDevEnum;
    return ERR_SUCCESS;
}

/*******************************************************************************
* Function Name  : EnumAllRootDevice
* Description    : öROOT-HUB˿ڵUSB豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   EnumAllRootDevice( void )
{
    UINT8   s;
#if DE_PRINTF
    printf( "EnumUSBDev\n" );
#endif
    if ( ThisUsbDev.DeviceStatus == ROOT_DEV_CONNECTED )                        // ղ豸δʼ
    {
        s = InitRootDevice( );                                      // ʼ/öָHUB˿ڵUSB豸
        USB_Port_Set(DISABLE, DISABLE); //usbӿùرսӿ
        Delay_Ms(700);
        USB_Port_Set(ENABLE, ENABLE);   //usbӿô򿪽ӿ
        USB_Interrupts_Config();    //usbж
        Set_USBConfig(); //usbʱ
        USB_Init();    //usbϵͳʼ

        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : InitDevOnHub
* Description    : ʼöⲿHUBĶUSB豸
* Input          : UINT8 HubPortIndex  ָⲿHUB
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_UNKNOWN δ֪豸
*******************************************************************************/
UINT8 InitDevOnHub( UINT8 HubPortIndex )
{
    UINT8   i, s, cfg, dv_cls, if_cls;
    UINT8   ifc;
#if DE_PRINTF
    printf( "Init dev @ExtHub-port_%1d ", (UINT16)HubPortIndex );
#endif
    if ( HubPortIndex == 0 )
    {
        return( ERR_USB_UNKNOWN );
    }
    SelectHubPort( HubPortIndex );                                      // ѡָROOT-HUB˿ڵⲿHUBָ˿,ѡٶ
#if DE_PRINTF
    printf( "GetDevDescr: " );
#endif
    s = CtrlGetDeviceDescr(Com_Buffer);                                          // ȡ豸
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    DevOnHubPort[HubPortIndex-1].DeviceVID = (((UINT16)((PXUSB_DEV_DESCR)Com_Buffer)->idVendor)); //VID PIDϢ
    DevOnHubPort[HubPortIndex-1].DevicePID = (((UINT16)((PXUSB_DEV_DESCR)Com_Buffer)->idProduct));

    dv_cls = ( (PXUSB_DEV_DESCR)Com_Buffer ) -> bDeviceClass;             // 豸
    cfg = ( 1<<4 ) + HubPortIndex;                                      // һUSBַ,ַص
    s = CtrlSetUsbAddress( cfg );                                       // USB豸ַ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    DevOnHubPort[HubPortIndex-1].DeviceAddress = cfg;                   // USBַ
#if DE_PRINTF
    printf( "GetCfgDescr: " );
#endif
    s = CtrlGetConfigDescr(Com_Buffer);                                          // ȡ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    cfg = ( (PXUSB_CFG_DESCR)Com_Buffer ) -> bConfigurationValue;
#if DE_PRINTF
    for ( i = 0; i < ( (PXUSB_CFG_DESCR)Com_Buffer ) -> wTotalLength; i ++ )
    {
        printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
    }
    printf("\n");
#endif
    /* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
    if_cls = ( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceClass; // ӿ
    if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE )                  // USB洢豸,ȷU
    {
        AnalyzeBulkEndp(Com_Buffer , HubPortIndex );
#if DE_PRINTF
        for(i=0;i!=4;i++)
        {
            printf("%02x ",(UINT16)DevOnHubPort[HubPortIndex-1].GpVar[i] );
        }
        printf("\n");
#endif
        s = CtrlSetUsbConfig( cfg );                                          // USB豸
        if ( s == ERR_SUCCESS )
        {
            DevOnHubPort[HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            DevOnHubPort[HubPortIndex-1].DeviceType = USB_DEV_CLASS_STORAGE;
#if DE_PRINTF
            printf( "USB-Disk Ready\n" );
#endif
            SetUsbSpeed( 1 );                                                 // ĬΪȫ
            return( ERR_SUCCESS );
        }
    }
    else if ( (dv_cls == 0x00) && (if_cls == USB_DEV_CLASS_HID) && (( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceSubClass <= 0x01) )    // HID豸,/
    {
        ifc = ( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> cfg_descr.bNumInterfaces;
        s = AnalyzeHidIntEndp( Com_Buffer, HubPortIndex);                                     // зHIDж϶˵ĵַ
#if DE_PRINTF
        printf( "AnalyzeHidIntEndp %02x\n",(UINT16)s );
#endif
        if_cls = ( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceProtocol;
        s = CtrlSetUsbConfig( cfg );                                           // USB豸
        if ( s == ERR_SUCCESS )
        {
            for(dv_cls=0;dv_cls<ifc;dv_cls++)
            {
                s = CtrlGetHIDDeviceReport(dv_cls);                    //ȡ
                if(s == ERR_SUCCESS)
                {
#if DE_PRINTF
                    for ( i = 0; i < 64; i++ )
                    {
                        printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
                    }
                    printf("\n");
#endif
                }
            }
            //豣˵ϢԱUSB
            DevOnHubPort[HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            if ( if_cls == 1 )
            {
                DevOnHubPort[HubPortIndex-1].DeviceType = DEV_TYPE_KEYBOARD;
                                                             //һʼ,豸ָʾLED
                if(ifc > 1)
                {
#if DE_PRINTF
                    printf( "USB_DEV_CLASS_HID Ready\n" );
#endif
                    DevOnHubPort[HubPortIndex-1].DeviceType = USB_DEV_CLASS_HID;//HID豸
                }
#if DE_PRINTF
                printf( "USB-Keyboard Ready\n" );
#endif
                SetUsbSpeed( 1 );                            // ĬΪȫ

                return( ERR_SUCCESS );
            }
            else if ( if_cls == 2 )
            {
                DevOnHubPort[HubPortIndex-1].DeviceType = DEV_TYPE_MOUSE;
                                                             //ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
                if(ifc > 1)
                {
#if DE_PRINTF
                    printf( "USB_DEV_CLASS_HID Ready\n" );
#endif
                    DevOnHubPort[HubPortIndex-1].DeviceType = USB_DEV_CLASS_HID;//HID豸
                }
#if DE_PRINTF
                printf( "USB-Mouse Ready\n" );
#endif
                SetUsbSpeed( 1 );                            // ĬΪȫ

                return( ERR_SUCCESS );
            }
            s = ERR_USB_UNSUPPORT;
        }
    }
    else if ( dv_cls == USB_DEV_CLASS_HUB )                                     // HUB豸,
    {
        DevOnHubPort[HubPortIndex-1].DeviceType = USB_DEV_CLASS_HUB;
#if DE_PRINTF
        printf( "This program don't support Level 2 HUB\n");                    // Ҫֶ֧༶HUBοչ
#endif
        s = HubClearPortFeature( i, HUB_PORT_ENABLE );                          // ֹHUB˿
        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
        s = ERR_USB_UNSUPPORT;
    }
    else                                                                //豸
    {
        AnalyzeBulkEndp(Com_Buffer , HubPortIndex );                      //˵
#if DE_PRINTF
        for(i=0;i!=4;i++)
        {
            printf("%02x ",(UINT16)DevOnHubPort[HubPortIndex-1].GpVar[i] );
        }
        printf("\n");
#endif
        s = CtrlSetUsbConfig( cfg );                                     // USB豸
        if ( s == ERR_SUCCESS )
        {
            //豣˵ϢԱUSB
            DevOnHubPort[HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            DevOnHubPort[HubPortIndex-1].DeviceType = dv_cls ? dv_cls : if_cls;
            SetUsbSpeed( 1 );                                                    // ĬΪȫ
            return( ERR_SUCCESS );                                               //δ֪豸ʼɹ
        }
    }
#if DE_PRINTF
    printf( "InitDevOnHub Err = %02X\n", (UINT16)s );
#endif
    DevOnHubPort[HubPortIndex-1].DeviceStatus = ROOT_DEV_FAILED;
    SetUsbSpeed( 1 );                                                            // ĬΪȫ
    return( s );
}
/*******************************************************************************
* Function Name  : EnumHubPort
* Description    : öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸
* Input          : UINT8 RootHubIndex ROOT_HUB0ROOT_HUB1
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           ʧ
*******************************************************************************/
UINT8 EnumHubPort( )
{
    UINT8   i, s;

    for ( i = 1; i <= ThisUsbDev.GpHUBPortNum; i ++ )                                       // ѯĶ˿Ƿб仯
    {
        SelectHubPort( 0 );                                                          // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
        s = HubGetPortStatus( i );                                                   // ȡ˿״̬
        if ( s != ERR_SUCCESS )
        {
            return( s );                                                              // ǸHUBϿ
        }
        if ( (( Com_Buffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) && ( Com_Buffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) ))||(Com_Buffer[2] == 0x10) )
        {                                                                            // 豸
            DevOnHubPort[i-1].DeviceStatus = ROOT_DEV_CONNECTED;                     // 豸
            DevOnHubPort[i-1].DeviceAddress = 0x00;
            s = HubGetPortStatus( i );                                               // ȡ˿״̬
            if ( s != ERR_SUCCESS )
            {
                return( s );                                                         // ǸHUBϿ
            }
            DevOnHubPort[i-1].DeviceSpeed = Com_Buffer[1] & (1<<(HUB_PORT_LOW_SPEED&0x07)) ? 0 : 1;// ٻȫ
            if ( DevOnHubPort[i-1].DeviceSpeed )
            {
#if DE_PRINTF
                printf( "Found full speed device on port %1d\n", (UINT16)i );
#endif
            }
            else
            {
#if DE_PRINTF
                printf( "Found low speed device on port %1d\n", (UINT16)i );
#endif
            }
            Delay_Ms( 200 );                                                          // ȴ豸ϵȶ
            s = HubSetPortFeature( i, HUB_PORT_RESET );                               // 豸ӵĶ˿ڸλ
            if ( s != ERR_SUCCESS )
            {
                return( s );                                                          // ǸHUBϿ
            }
#if DE_PRINTF
            printf( "Reset port and then wait in\n" );
#endif
            do                                                                        // ѯλ˿,ֱλ,ɺ״̬ʾ
            {
                Delay_Ms( 1 );
                s = HubGetPortStatus( i );
                if ( s != ERR_SUCCESS )
                {
                    return( s );                                                      // ǸHUBϿ
                }
            }
            while ( Com_Buffer[0] & (1<<(HUB_PORT_RESET&0x07)) );                       // ˿ڸλȴ
            Delay_Ms( 100 );
            s = HubClearPortFeature( i, HUB_C_PORT_RESET );                           // λɱ־
//             s = HubSetPortFeature( i, HUB_PORT_ENABLE );                              // HUB˿
            s = HubClearPortFeature( i, HUB_C_PORT_CONNECTION );                      // ӻƳ仯־
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            s = HubGetPortStatus( i );                                                // ٶȡ״̬,豸Ƿ
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            if ( ( Com_Buffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 )
            {
                DevOnHubPort[i-1].DeviceStatus = ROOT_DEV_DISCONNECT;                 // 豸
            }
            s = InitDevOnHub( i );                                                    // ʼUSB豸
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            SetUsbSpeed( 1 );                                                         // ĬΪȫ
        }
        else if (Com_Buffer[2]&(1<<(HUB_C_PORT_ENABLE&0x07))  )                         // 豸ӳ
        {
            HubClearPortFeature( i, HUB_C_PORT_ENABLE );                              // Ӵ־
#if DE_PRINTF
            printf( "Device on port error\n" );
#endif
            s = HubSetPortFeature( i, HUB_PORT_RESET );                               // 豸ӵĶ˿ڸλ
            if ( s != ERR_SUCCESS )
            return( s );                                                              // ǸHUBϿ
            do                                                                        // ѯλ˿,ֱλ,ɺ״̬ʾ
            {
                Delay_Ms( 1 );
                s = HubGetPortStatus( i );
                if ( s != ERR_SUCCESS ) return( s );                                    // ǸHUBϿ
            } while ( Com_Buffer[0] & (1<<(HUB_PORT_RESET&0x07)) );                     // ˿ڸλȴ
        }
        else if ( ( Com_Buffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 )              // 豸ѾϿ
        {
            if ( DevOnHubPort[i-1].DeviceStatus >= ROOT_DEV_CONNECTED )
            {
#if DE_PRINTF
                printf( "Device on port %1d removed\n", (UINT16)i );
#endif
            }
            DevOnHubPort[i-1].DeviceStatus = ROOT_DEV_DISCONNECT;                     // 豸
            if ( Com_Buffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) )
            {
                HubClearPortFeature( i, HUB_C_PORT_CONNECTION );                      // Ƴ仯־
            }
        }
    }
    return( ERR_SUCCESS );                                                            // زɹ
}
/*******************************************************************************
* Function Name  : EnumAllHubPort
* Description    : öROOT-HUB˿ⲿHUBĶUSB豸
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           ʧ
*******************************************************************************/
UINT8   EnumAllHubPort( void )
{
    UINT8   s;

    if ( (ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS) && (ThisUsbDev.DeviceType == USB_DEV_CLASS_HUB) )// HUBöٳɹ
    {
        SelectHubPort( 0 );                                                        // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
        //ʲô?  HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
//             for ( i = 1; i <= ThisUsbDev.GpVar; i ++ ){                             // ʼHUB˿
//               s = HubSetPortFeature( i, HUB_PORT_POWER );                           // HUB˿ϵ
//               if ( s != ERR_SUCCESS )
//               {
//                 return( s );                                                        // ǸHUBϿ
//               }
//             }
        s = EnumHubPort( );                                                        // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼
        if ( s != ERR_SUCCESS )                                                    // HUBϿ
        {
#if DE_PRINTF
            printf( "EnumAllHubPort err = %02X\n", (UINT16)s );
#endif
        }
        SetUsbSpeed( 1 );                                                          // ĬΪȫ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : SearchTypeDevice
* Description    : ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
* Input          : UINT8 type 豸
* Output         : None
* Return         : 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
                   ȻҲԸUSBĳVIDƷPID(Ҫ¼豸VIDPID),Լָ
*******************************************************************************/
UINT16  SearchTypeDevice( UINT8 type )
{
    UINT8  RootHubIndex;                                                          //ֻһUSB,RootHubIndex = 0,ֻ迴ֵĵͰλ
    UINT8  HubPortIndex;

    RootHubIndex = 0;
    if ( (ThisUsbDev.DeviceType == USB_DEV_CLASS_HUB) && (ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS) )// ⲿHUBöٳɹ
    {
        for ( HubPortIndex = 1; HubPortIndex <= ThisUsbDev.GpHUBPortNum; HubPortIndex ++ )// ⲿHUBĸ˿
        {
            if ( DevOnHubPort[HubPortIndex-1].DeviceType == type && DevOnHubPort[HubPortIndex-1].DeviceStatus >= ROOT_DEV_SUCCESS )
            {
                return( ( (UINT16)RootHubIndex << 8 ) | HubPortIndex );           // ƥöٳɹ
            }
        }
    }
    if ( (ThisUsbDev.DeviceType == type) && (ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS) )
    {
        return( (UINT16)RootHubIndex << 8 );                                      // ƥöٳɹ,ROOT-HUB˿
    }

    return( 0xFFFF );
}
/*******************************************************************************
* Function Name  : SETorOFFNumLock
* Description    : NumLockĵж
* Input          : PUINT8 buf Ƽֵ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 SETorOFFNumLock(PUINT8 buf)
{
    UINT8 tmp[]= {0x21,0x09,0x00,0x02,0x00,0x00,0x01,0x00};
    UINT8 len,s;
    if((buf[2]==0x53)&(buf[0]|buf[1]|buf[3]|buf[4]|buf[5]|buf[6]|buf[7]==0))
    {
        for ( s = 0; s != sizeof( tmp ); s ++ )
        {
            ((PUINT8)pSetupReq)[ s ] = tmp[s];
        }
        s = HostCtrlTransfer( Com_Buffer, &len );                                     // ִпƴ
        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
    }
    return( ERR_SUCCESS );
}
#endif


#ifdef DISK_BASE_BUF_LEN
UINT8 InitRootDevice( void )                                                       // ʼUSB豸
{
    UINT8   i, s, cfg, dv_cls, if_cls;
#if DE_PRINTF
    printf( "Reset host port\n" );
#endif
    ResetRootHubPort( );                                                            // ⵽豸,λӦ˿ڵUSB
    for ( i = 0, s = 0; i < 100; i ++ ) {                                           // ȴUSB豸λ,100mSʱ
        Delay_Ms( 1 );
        if ( EnableRootHubPort( ) == ERR_SUCCESS ) {                                  // ʹܶ˿
            i = 0;
            s ++;                                                                       // ʱȴUSB豸Ӻȶ
            if ( s > 100 ) break;                                                       // Ѿȶ100mS
        }
    }
    if ( i ) {                                                                      // λ豸û
        DisableRootHubPort( );
#if DE_PRINTF
        printf( "Disable host port because of disconnect\n" );
#endif
        return( ERR_USB_DISCON );
    }
    SetUsbSpeed( 1 );                                                              // õǰUSBٶ
    s = CtrlGetDeviceDescr( );                                                     // ȡ豸
    if ( s == ERR_SUCCESS ) {
#if DE_PRINTF
      printf( "GetDevDescr: " );
        for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ ) printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
        printf( "\n" );                                                             // ʾ
#endif
        dv_cls = ( (PXUSB_DEV_DESCR)Com_Buffer ) -> bDeviceClass;                     // 豸
        s = CtrlSetUsbAddress( ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );    // USB豸ַ
        if ( s == ERR_SUCCESS ) {
            s = CtrlGetConfigDescr( );                                                // ȡ
            if ( s == ERR_SUCCESS ) {
                cfg = ( (PXUSB_CFG_DESCR)Com_Buffer ) -> bConfigurationValue;
#if DE_PRINTF
              printf( "GetCfgDescr: " );
                for ( i = 0; i < ( (PXUSB_CFG_DESCR)Com_Buffer ) -> wTotalLengthL; i ++ )
                    printf( "x%02X ", (UINT16)( Com_Buffer[i] ) );
                printf("\n");
#endif
/* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
                if_cls = ( (PXUSB_CFG_DESCR_LONG)Com_Buffer ) -> itf_descr.bInterfaceClass; // ӿ
                if ( (dv_cls == 0x00) && (if_cls == USB_DEV_CLASS_STORAGE) ) {            // USB洢豸,ȷU
//                  s = CtrlSetUsbConfig( cfg );                                     // USB豸
//                    if ( s == ERR_SUCCESS )
                    {
                        CH549DiskStatus = DISK_USB_ADDR;
                        return( ERR_SUCCESS );
                    }
//                  else return( ERR_USB_UNSUPPORT );
                }
                else {
                    return( ERR_USB_UNSUPPORT );
                }
            }
        }
    }
#if DE_PRINTF
    printf( "InitRootDev Err = %02X\n", (UINT16)s );
#endif
    CH549DiskStatus = DISK_CONNECT;
    SetUsbSpeed( 1 );                                                              // ĬΪȫ
    return( s );
}


#endif
/*******************************************************************************
* Function Name  : USB_HostInit
* Description    : Initializes USB host mode.
* Input          : None
* Return         : None
*******************************************************************************/
void  USB_HostInit( void )
{
    R8_USB_CTRL = RB_UC_HOST_MODE; // 趨ģʽ
    R8_UHOST_CTRL = 0;             //
    R8_USB_DEV_AD = 0x00;
    R8_UH_EP_MOD = RB_UH_EP_TX_EN | RB_UH_EP_RX_EN;
    R16_UH_RX_DMA = (UINT16)(UINT32)pHOST_RX_RAM_Addr;
    R16_UH_TX_DMA = (UINT16)(UINT32)pHOST_TX_RAM_Addr;

    R8_UH_RX_CTRL = 0x00;
    R8_UH_TX_CTRL = 0x00;
    R8_USB_CTRL =  RB_UC_HOST_MODE | RB_UC_INT_BUSY | RB_UC_DMA_EN; // USBDMA,жϱ־δǰԶͣ
    R8_UH_SETUP = RB_UH_SOF_EN;
    R8_USB_INT_FG = 0xFF; // жϱ־
     for (UINT8 i = 0; i != 2; i ++ )
     {
         DisableRootHubPort( );                                                   // 
     }
    R8_USB_INT_EN = RB_UIE_TRANSFER|RB_UIE_DETECT;

    FoundNewDev = 0;
}
