#include "debug.h"
#include "ch32f10x_usb_host.h"
#include "usb_lib.h"
#include "hw_config.h"
#include "usb_pwr.h"

/**
   *  ֧ӿ
 */

/* Global Variable */ 
__attribute__ ((aligned(4))) UINT8  RxBuffer[ MAX_PACKET_SIZE ] ;      // IN, must even address
__attribute__ ((aligned(4))) UINT8  TxBuffer[ MAX_PACKET_SIZE ] ;      // OUT, must even address
__attribute__ ((aligned(4))) UINT8  Com_Buffer[ 128 ];                 // ûʱöʱڴöٽҲͨʱ

/*******************************************************************************
* Function Name  : Set_USBConfig
* Description    : Set USB clock.
* Input          : None
* Return         : None
*******************************************************************************/
void USBHD_ClockCmd(UINT32 RCC_USBCLKSource,FunctionalState NewState)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, NewState);
    EXTEN->EXTEN_CTR |= EXTEN_USBHD_IO_EN;
    RCC_USBCLKConfig(RCC_USBCLKSource);             //USBclk=PLLclk/1.5=48Mhz
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_USBHD,NewState);
}
/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
    UINT8   i, s,k, len, endp;
    UINT16  loc;
    INT8 FLAG=0;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init();
	USART_Printf_Init(115200);
	USBHD_ClockCmd(RCC_USBCLKSource_PLLCLK_1Div5,ENABLE);//usbʱ
	pHOST_RX_RAM_Addr = RxBuffer;
	pHOST_TX_RAM_Addr = TxBuffer;
	USB_HostInit();//usbʼ


    printf( "Wait Device In\n" );

    while(1)
    {

        s = ERR_SUCCESS;

       if ( R8_USB_INT_FG & RB_UIF_DETECT )//ӻϿжϱ־
       {
           R8_USB_INT_FG = RB_UIF_DETECT ;

           s = AnalyzeRootHub( ); //root-hub״̬
           if ( s == ERR_USB_CONNECT )
           {
               printf( "New Device In\r\n" );
               FoundNewDev = 1;
           }
           if( s == ERR_USB_DISCON )
           {
               printf( "Device Out\r\n" );
           }
       }

       if ( FoundNewDev || s == ERR_USB_CONNECT )//USB豸
       {
           FoundNewDev = 0;
           Delay_Ms( 200 );//USB豸ղδȶʵȴ豸ٺ룬ζ
           s = EnumAllRootDevice( );                                            // öROOT-HUB˿ڵUSB豸
           if ( s != ERR_SUCCESS )
           {

               printf( "EnumAllRootDev err = %02X\n", (UINT16)s );
           }
       }

       /* 豸 */
            loc = SearchTypeDevice( DEV_TYPE_MOUSE );                             // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
            if ( loc != 0xFFFF )                                                  // ҵ,MOUSEδ?
            {
                i = (UINT8)( loc >> 8 );
                len = (UINT8)loc;
                SelectHubPort( len );                                             // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
                endp = len ? DevOnHubPort[len-1].GpVar[0] : ThisUsbDev.GpVar[0];        // ж϶˵ĵַ,λ7ͬ־λ
                if ( endp & USB_ENDP_ADDR_MASK )                                  // ˵Ч
                {
                    s = USBHostTransact( USB_PID_IN << 4 | (endp & 0x7F), endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0 );//,ȡ,NAK
                    if ( s == ERR_SUCCESS )
                    {
                        endp ^= 0x80;                                             // ͬ־ת
                        if ( len )
                        {
                            DevOnHubPort[len-1].GpVar[0] = endp;    // ͬ־λ
                        }
                        else
                        {
                            ThisUsbDev.GpVar[0] = endp;
                        }
                        len = R8_USB_RX_LEN;                                         // յݳ
                        if ( len )
                        {
                            USBD_Send(RxBuffer,len);
                        }
                    }
                    else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
                    {
                        printf("Mouse error %02x\n",(UINT16)s);                   // ǶϿ
                    }
                }
                else
                {
                    printf("Mouse no interrupt endpoint\n");
                }
                SetUsbSpeed( 1 );                                                 // ĬΪȫ
            }

            /* 豸Ǽ */
            loc = SearchTypeDevice( DEV_TYPE_KEYBOARD );                             // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
            if ( loc != 0xFFFF )                                                  // ҵ,MOUSEδ?
            {
                i = (UINT8)( loc >> 8 );
                len = (UINT8)loc;
                SelectHubPort( len );                                             // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
                endp = len ? DevOnHubPort[len-1].GpVar[0] : ThisUsbDev.GpVar[0];        // ж϶˵ĵַ,λ7ͬ־λ
                if ( endp & USB_ENDP_ADDR_MASK )                                  // ˵Ч
                {
                    s = USBHostTransact( USB_PID_IN << 4 | (endp & 0x7F), endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0 );//,ȡ,NAK
                    if ( s == ERR_SUCCESS )
                    {
                        endp ^= 0x80;                                             // ͬ־ת
                        if ( len )
                      {
                            DevOnHubPort[len-1].GpVar[0] = endp;    // ͬ־λ
                      }
                      else
                      {
                            ThisUsbDev.GpVar[0] = endp;
                      }
                      len = R8_USB_RX_LEN;                                         // յݳ
                      if ( len )
                      {
                          SETorOFFNumLock(RxBuffer);
                          printf("keyboard data: ");
                          for ( i = 0; i < len; i ++ )
                          {
                              printf("x%02X ",(UINT16)(RxBuffer[i]) );
                          }
                          printf("\n");
                          USBD_Send(RxBuffer,len);
                      }
                  }
                  else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
                  {
                      printf("keyboard error %02x\n",(UINT16)s);                   // ǶϿ
                  }
              }
              else
              {
                  printf("keyboard no interrupt endpoint\n");
              }
              SetUsbSpeed( 1 );                                                 // ĬΪȫ
          }

            /* HID豸 */
            loc = SearchTypeDevice( USB_DEV_CLASS_HID );                             // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
            if ( loc != 0xFFFF )                                                  // ҵ,MOUSEδ?
            {
            //            printf( "Query Mouse @%04X\n", loc );
              loc = (UINT8)loc;
              for(k=0; k!=4; k++)
              {
                  //˵ǷЧ
                  endp = loc ? DevOnHubPort[loc-1].GpVar[k] : ThisUsbDev.GpVar[k];        // ж϶˵ĵַ,λ7ͬ־λ
                  if ( (endp & USB_ENDP_ADDR_MASK) == 0 )
                  {
                      break;
                  }
//                  printf("endp: %02X\n",(UINT16)endp);
                  SelectHubPort( loc );   // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
                  s = USBHostTransact( USB_PID_IN << 4 | (endp & 0x7F), endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0 );//,ȡ,NAK
                  if ( s == ERR_SUCCESS )
                  {
                      endp ^= 0x80;                                             // ͬ־ת
                      if ( loc )
                      {
                          DevOnHubPort[loc-1].GpVar[k] = endp;                   // ͬ־λ
                      }
                      else
                      {
                          ThisUsbDev.GpVar[k] = endp;
                      }
                      len = R8_USB_RX_LEN;                                         // յݳ
                      if ( len )
                      {
                          printf("keyboard data: ");
                          for ( i = 0; i < len; i ++ )
                          {
                              printf("x%02X ",(UINT16)(RxBuffer[i]) );
                          }
                          printf("\n");
                          USBD_Send(RxBuffer,len);
                      }
                  }
                  else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
                  {
                      printf("keyboard error %02x\n",(UINT16)s);               //ǶϿ
                  }
              }
                  SetUsbSpeed( 1 );                                                 // ĬΪȫ
              }

    }

}
