/********************************** (C) COPYRIGHT *******************************
* File Name          : usb_desc.h
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : This file contains all the functions prototypes for the  
*                      USB description firmware library.
*******************************************************************************/ 
#ifndef __USB_DESC_H
#define __USB_DESC_H

#ifdef __cplusplus
 extern "C" {
#endif
	 
#include "ch32f10x.h"
#include "usb_core.h"
	 
#define USB_DEVICE_DESCRIPTOR_TYPE              0x01
#define USB_CONFIGURATION_DESCRIPTOR_TYPE       0x02
#define USB_STRING_DESCRIPTOR_TYPE              0x03
#define USB_INTERFACE_DESCRIPTOR_TYPE           0x04
#define USB_ENDPOINT_DESCRIPTOR_TYPE            0x05

#define USBD_DATA_SIZE               64
#define USBD_INT_SIZE                8
       
#define USBD_SIZE_DEVICE_DESC        18
#define USBD_SIZE_CONFIG_DESC        255
#define USBD_SIZ_HID_DESC                   0x09
	 
#define ReportDescriptor_Size				255
	 
#define USBD_SIZE_STRING_LANGID      4
#define USBD_SIZE_STRING_VENDOR      38
#define USBD_SIZE_STRING_PRODUCT     50
#define USBD_SIZE_STRING_SERIAL      26

#define HID_DESCRIPTOR_TYPE                     0x21
#define STANDARD_ENDPOINT_DESC_SIZE             0x09
/*****************/
#define Interface0_OFF_HID_DESC						50
#define Interface1_OFF_HID_DESC                     50
#define Interface2_OFF_HID_DESC                     50
/*****************/
extern u8  Interface0RepDesc[];
extern u8  Interface1RepDesc[];
extern u8  Interface2RepDesc[];

extern uint8_t USBD_DeviceDescriptor[];
extern uint8_t USBD_ConfigDescriptor[];
                    
extern uint8_t USBD_StringLangID [];
extern uint8_t USBD_StringVendor [];
extern uint8_t USBD_StringProduct[];
extern uint8_t USBD_StringSerial [];
RESULT USBD_SetProtocol(void);
u8 *USBD_GetProtocolValue(u16 Length);
RESULT USBD_SetProtocol(void);
#ifdef __cplusplus
}
#endif

#endif /* __USB_DESC_H */
